clear;clc;
addpath('D:\BRPCA_HIC_DEFS\matlab_bgl');
% It makes extensive use of graph-theoretic filtering technique 
% called Triangulated Maximally Filtered Graph (TMFG) which can be downloaded in http://www.mathworks.com/matlabcentral/fileexchange/10922
RandStream.setGlobalStream(RandStream('mt19937ar','Seed', 5489));
load('D:\BRPCA_HIC_DEFS\RBPCA_DATA\output_300_K30_P_172_dep_0915_gene_3_all_0915v6.mat');
%L = Output.Lowrank_mean;
S = Output.Sparse_mean;
data = S;
[P,N] =size(data);
R=zeros(N,N)+diag(ones(N,1));
% Compute the pair-wise correlation of gene expression data
for n=1:(N-1);
    nvec=data(:,n);
    for m=(n+1):N;
        mvec=data(:,m);
        i=(isnan(nvec)~=1&isnan(mvec)~=1);% identify non-NaN entries
        R(n,m)=corr(nvec(i),mvec(i));% Compute Pearson's correlation coefficient
    end
end
R=R+R' - diag(ones(N,1));% Symmetrize correlation matrix
D=sqrt(2*(1-R));% Correlation distance 2
[T8_mRNA,Rpm,Adjv,Dpm,Mv]=DBHT(D,R);% Compte DBHT h clustering   % D = NxN dissimilarity matrix.    % R = NxN similarity matrix.
%ϾdoPMFG.mwhile( E < 3*(N-2) ) % continue while all edges for a maximal planar graph are inserted
Z=HierarchyConstruct4(Rpm,Dpm,T8_mRNA,Adjv,Mv);% Compute DBHT hierarchy
X=DrawPMFG(Rpm,T8_mRNA,0);close

%clustermarker={'d';'o';'o';'s';'d';'o';'d';'o';'d';'o'};
clustermarker={'d';'o';'h';'s';'v';'^';'<';'>';'p';'o';'d';'o';'o'};
textlabel={'1:MSI/CIMP';'2:CIN';'3:invasive';'4:Normal';'Unknown'};
xtext=max(X(:,1))-(max(X(:,1))-min(X(:,1)))/5;
ytext=max(X(:,2))-(max(X(:,2))-min(X(:,2)))/6;

cmap=[];
for r=1:2;
    for g=1:2
        for b=1:2;
            cmap=[cmap;1/2*r 1/2*g 1/2*b];
        end
    end
end

fid = fopen('coad_nature_clinical153.csv');  
dcells = textscan(fid, '%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s','delimiter', ',');
fclose(fid);  


% Lable = dcells{1,3};  %%methylation_subtype
% a = strrep(Lable,'CIMP.H','H') ;
% b = strrep(a,'CIMP.L','L') ;
% c = strrep(b,'Cluster3','3') ;
% d = strrep(c,'Cluster4','4') ;
% 
% Lable = dcells{1,6};     %%ٴ
% a = strrep(Lable,'Stage I','I') ;
% b = strrep(a,'Stage IV','IV') ;
% c = strrep(b,'Stage IIA','IIA') ;
% d = strrep(c,'Stage IIB','IIB') ;
% e = strrep(d,'Stage IIIC','IIIC') ;
% f = strrep(e,'Stage IIIA','IIIA') ;
% g = strrep(f,'Stage IV','IV') ;
% h = strrep(g,'Stage IVA','IVA') ;

Lable = dcells{1,14};    %%expression_subtype
a = strrep(Lable,'MSI/CIMP','1') ;
b = strrep(a,'CIN','2') ;
c = strrep(b,'Invasive','3') ; 
for i = 155:173
    c{i} = '4';
end
% for i = 127:145
%     c{i} = '4';
% end
% %%%%%%%%%%%%%%%%%%%%%%%֮ǰȲãren_result
% fid = fopen('ren_result.csv');  
% dcells = textscan(fid, '%s%s%s%s','delimiter', ',');
% fclose(fid);  
% lable= dcells{1,2};
% c=lable;
% for i = 155:173
%     c{i} = '4';
% end

fid = fopen('coad_nature_clinical153.csv');  
dcells = textscan(fid, '%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s','delimiter', ',');
fclose(fid);  

%ΪPCA֮ǰŹ
% for i = 1:97
%     c{i} = '1';
% end
% for i = 98:126
%     c{i} = '2';
% end
% for i = 127:145
%     c{i} = 'N';
% end

% Lable = dcells{1,2};    %%MSI_status
% a = strrep(Lable,'MSI-H','1') ;
% b = strrep(a,'MSI-L','2') ;
% c = strrep(b,'MSS','3') ;

% Lable = dcells{1,5};
% a = strrep(Lable,'T1','1') ;
% b = strrep(a,'T2','2') ;
% c = strrep(b,'T3','3') ;
% 
% T8_mRNA(T8_mRNA==6)=5;

figure;gplot(Rpm,X,'b-');hold on
for n=1:size(X,1);
    H(n) = plot(X(n,1),X(n,2),clustermarker{T8_mRNA(n)},'markerfacecolor',cmap(T8_mRNA(n),:),'markeredgecolor','k','markersize',18);%20
end
for n=1:size(X,1);
    text(X(n,1),X(n,2),c{n+1},'HorizontalAlignment','center','fontweight','bold','fontangle','italic','fontsize',10.5);
end
text(xtext,ytext,textlabel,'fontweight','demi','fontsize',12);%,'fontangle','italic');
legend(H([4,33,34,31,1,37,53,154]),'cluster 1','cluster 2','cluster 3','cluster 4','cluster 5','cluster 6','cluster 7','cluster 8');
%legend(H([3,143,1,2]),'cluster 1','cluster 2','cluster 3','cluster 4');%%ûBRPCA
% hleg1 = legend('','cluster 1','cluster 2','cluster 3','cluster 4','cluster 5','cluster 6','cluster 7','cluster 8');
% set(hleg1,'Location','NorthWest')
hold off
gca
orient landscape

daystoalive =dcells{1,24};
%daystoalive = daystoalive{2:154,1};
Censored = dcells{1,45}; 
Censored = strrep(Censored,'DECEASED','0') ;
Censored = strrep(Censored,'LIVING','1') ;

days_alive = zeros(153,1);
censored_state = zeros(153,1);
for i = 2:154
   days_alive(i-1) = str2num(daystoalive{i}) ;
   censored_state(i-1) = str2num(Censored{i});
end
SurvivorData = [days_alive,censored_state];
% i = find(days_alive==0);
% SurvivorData(i,2) = 0; 

i1 = find(T8_mRNA==1);
g1 = SurvivorData(i1,:);
i2 = find(T8_mRNA==2);
g2 = SurvivorData(i2,:);
i3 = find(T8_mRNA==3);
g3 = SurvivorData(i3,:);
i4 = find(T8_mRNA==4);
g4 = SurvivorData(i4,:);
i5 = find(T8_mRNA==5);
g5 = SurvivorData(i5,:);
i6 = find(T8_mRNA==6);  
g6 = SurvivorData(i6,:);
i7 = find(T8_mRNA==7);
g7 = SurvivorData(i7,:);
i8 = find(T8_mRNA==8);%%%%%%%
% g8 = SurvivorData(i8,:);
% 
% rawdata = csvread('data8/COADmRNA_all.csv',1,1);
% g1rawdata = rawdata(:,i1);
% g2rawdata = rawdata(:,i2);
% g3rawdata = rawdata(:,i3);
% g4rawdata = rawdata(:,i4);
% g5rawdata = rawdata(:,i5);
% %g6rawdata = data2;        %
% g7rawdata = rawdata(:,i7);
% g8rawdata = rawdata(:,i8);
% 
% g1data = data(:,i1);
% g2data = data(:,i2);
% g3data = data(:,i3);
% g4data = data(:,i4);
% g5data = data(:,i5);
% %g6data = data(:,i6);
% g7data = data(:,i7);
% g8data = data(:,i8);
% % save('group_raw_data.mat','g1rawdata','g2rawdata','g3rawdata','g4rawdata','g5rawdata','g6rawdata','g7rawdata','g8rawdata');
% % save('group_rbpca_data.mat','g1data','g2data','g3data','g4data','g5data','g6data','g7data','g8data');  %6˵
% %load('group_raw_data.mat');
% 
% figure()
% ecdf(gca,g1(:,1),'Censoring',g1(:,2));
% hold on
% [f,x] = ecdf(g2(:,1),'Censoring',g2(:,2));
% stairs(x,f,':r')
% 
% [f,x] = ecdf(g3(:,1),'Censoring',g3(:,2));
% stairs(x,f,'-g')
% 
% [f,x] = ecdf(g4(:,1),'Censoring',g4(:,2));
% stairs(x,f,'-b')
% 
% [f,x] = ecdf(g5(:,1),'Censoring',g5(:,2));
% stairs(x,f,'-.r')
% 
% [f,x] = ecdf(g6(:,1),'Censoring',g6(:,2));
% stairs(x,f,'-.r')
% 
% [f,x] = ecdf(g7(:,1),'Censoring',g7(:,2));
% stairs(x,f,'-.g')
% 
% hold off
% 
% 
figure()
% ecdf(gca,g1(:,1),'Censoring',g1(:,2));
% hold on
% [f,x] = ecdf(g1(:,1),'Censoring',g1(:,2));
% stairs(x,f,'Color','b','LineStyle','-','LineWidth',2)
% 
% [f,x] = ecdf(g2(:,1),'Censoring',g2(:,2));
% stairs(x,f,'Color','r','LineStyle','-','LineWidth',2)
% 
% [f,x] = ecdf(g3(:,1),'Censoring',g3(:,2));
% stairs(x,f,'Color','g','LineStyle','-','LineWidth',2)
% 
% [f,x] = ecdf(g4(:,1),'Censoring',g4(:,2));
% stairs(x,f,'Color','r','LineStyle','-.','LineWidth',2)
% 
% [f,x] = ecdf(g5(:,1),'Censoring',g5(:,2));
% stairs(x,f,'Color','g','LineStyle','-.','LineWidth',2)
% hold on
% [f,x] = ecdf(g6(:,1),'Censoring',g6(:,2));            %%%%g7ʷǳߵһ
% stairs(x,f,'Color','b','LineStyle','-.','LineWidth',2)
% hold on
% [f,x] = ecdf(g7(:,1),'Censoring',g7(:,2));
% stairs(x,f,'Color','r','LineStyle',':','LineWidth',2)
% hold off

logrank(g1,g5);
% logrank(g1,g7);


% % Step 3. Plot survivor functions.
%ecdf(gca,g1(:,1),'Censoring',g1(:,2),'function','survivor');

%[f,x] = ecdf(g1(:,1),'Censoring',g1(:,2),'function','survivor');
%hold on
figure()
[f,x] = ecdf(g1(:,1),'Censoring',g1(:,2),'function','survivor');
stairs(x,f,'Color',cmap(1,:),'LineStyle','-','LineWidth',1.5)
hold on;
[f,x] = ecdf(g2(:,1),'Censoring',g2(:,2),'function','survivor');
stairs(x,f,'Color',cmap(2,:),'LineStyle','-','LineWidth',1.5)
hold on;
[f,x] = ecdf(g3(:,1),'Censoring',g3(:,2),'function','survivor');
stairs(x,f,'Color',cmap(3,:),'LineStyle','-','LineWidth',1.5)
hold on;
[f,x] = ecdf(g4(:,1),'Censoring',g4(:,2),'function','survivor');
stairs(x,f,'Color',cmap(4,:),'LineStyle','-','LineWidth',1.5)
hold on;
[f,x] = ecdf(g5(:,1),'Censoring',g5(:,2),'function','survivor');
stairs(x,f,'Color',cmap(5,:),'LineStyle','-','LineWidth',1.5)
hold on;
[f,x] = ecdf(g6(:,1),'Censoring',g6(:,2),'function','survivor');
stairs(x,f,'Color',cmap(6,:),'LineStyle','-','LineWidth',1.5)
hold on;
[f,x] = ecdf(g7(:,1),'Censoring',g7(:,2),'function','survivor');
stairs(x,f,'Color',cmap(7,:),'LineStyle','-','LineWidth',1.5)
hleg1 = legend('cluster 1','cluster 2','cluster 3','cluster 4','cluster 5','cluster 6','cluster 7');
set(hleg1,'Location','NorthWest')
hold off
